﻿Type=Class
Version=2
ModulesStructureVersion=1
B4i=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	Private iSock As Socket
	Private iStream As AsyncStreams
	Private iAES As Cipher
	
	'16 zeros IV 
	Private IV() As Byte = Array As Byte(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
	Private Key() As Byte = Array As Byte(0x8A, 0x39, 0xD1, 0xC5, 0x26, 0x14, 0xEB, 0x04, 0x7F, 0x82, 0xCA, 0x57, 0xA1, 0x3E, 0xC6, 0xBD)
	
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize

	iSock.Initialize("iSock")

End Sub

public Sub ConnectToDevice
	
	iSock.Connect("Device IP", 1000, 0)
	
End Sub

private Sub iSock_Connected(Successfull As Boolean)
	
	If Successfull = True Then
	
		iStream.Initialize(iSock.InputStream, iSock.OutputStream, "iStream")
		
		'Send something to the connected device
		Dim byte2Send(16) As Byte = Array As Byte(10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
		byte2Send = iAES.Encrypt2(byte2Send, Key, "AES", IV, 0)
		iStream.Write(byte2Send)
		
	End If
	
End Sub

private Sub iStream_NewData (Buffer() As Byte)
	If Buffer.Length > 0 Then
	
		Dim DecryptedResponse(Buffer.Length) As Byte
		DecryptedResponse = iAES.Decrypt2(Buffer, Key, "AES", IV, 0)
		
		'Do something with the decrypted response
	End If
	
End Sub